
{procedure that activates reverse video mode}
procedure reverse_on;
begin
 textcolor(blue);
 textbackground(lightgray);
end;

{procedure that deactivates reverse video mode}
procedure reverse_off;
begin
 textcolor(white);
 textbackground(blue);
end;

{procedure that activates bold character mode}
procedure bold_on;
begin
 textcolor(yellow);
 textbackground(blue);
end;

{procedure that deavtivates bold character mode}
procedure bold_off;
begin
 textcolor(white);
 textbackground(blue);
end;

{procedure that clears the CRT from current position to the
 end of the screen (IBM). Version 1.0 by R.P.Helmle on 02 Sep 86}
procedure clreos;
TYPE
 DosRegs = record
            ax,bx,cx,dx,bp,si,di,ds,es,Flags : integer;
           end;
VAR {declaration of globally accessible variables}
 result           : DosRegs;
 current          : integer;
begin
 clreol;
 current := WhereY + 1;
 repeat
   gotoxy(1,current);clreol;
   current := succ(current);
 until current = 26;
end;

{procedure that clears from current cursor position to end of line}
{procedure clreol;
begin
 clreol;
 write(output,chr(27),'[K');
end;}

{procedure that beeps the keyboard buzzer}
procedure beep;
begin
 write(output,chr(7));
end;

{procedure that flashes an error message on the screen
 variable description:
 msg : string variable containing error message to display
 index : control vaiable in LOOP to control flashing
}
procedure error(noise,flash : integer;msg : str80);
var pause : char;
begin
reverse_off;
if (noise = 1) then beep;
 textcolor(blue);
 textbackground(red);
 gotoxy(1,24);write(output,msg);
 read(KBD,pause);
 textbackground(blue);
 gotoxy(1,24);clreol;
 bold_off;
end;

{procedure that turns off the cursor on CRT on an IBM compatible
 unit.                    Version 1.0 by R.P.Helmle on 02 Sep 86}
procedure cursor_off;
TYPE
 DosRegs = record
            ax,bx,cx,dx,bp,si,di,ds,es,Flags : integer;
           end;
VAR {declaration of globally accessible variables}
 result           : DosRegs;
begin
 result.ax := $0100;
 result.cx := $0909;
 Intr($10,result);
end;

{procedure that turns on the cursor on CRT on an IBM compatible
 unit.                    Version 1.0 by R.P.Helmle on 02 Sep 86}
procedure cursor_on;
TYPE
 DosRegs = record
            ax,bx,cx,dx,bp,si,di,ds,es,Flags : integer;
           end;
VAR {declaration of globally accessible variables}
 result           : DosRegs;
begin
 result.ax := $0100;
 result.cx := $0708;
 Intr($10,result);
end;
